<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-state-server", {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim-xml/disXmlState:disXmlState.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim-xml/disXmlState:disXmlState.label.node-conf')
      },
      serviceName: {
        property: "serviceName",
        label: RED._('node-red-dim-xml/disXmlState:disXmlState.label.service-name')
      },
      orderedList: {
        label: RED._('node-red-dim-xml/disXmlState:disXmlState.label.ordered-list'),
        selector: true
      }
    });

    RED.nodes.registerType("dim-xml-state-server", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-xml-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(disXml.regExp.srvName)
        },
        states: { value: [] },
        initState: { value: "", required: true }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 1,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML State Server");
      },
      oneditprepare: function() {
        const node = this;

        node._stateList = disXml.editor.buildEnumList(
          {
            firstValue: 0,
            valueWidth: '80px',
            valueLabel: node._('disXmlState.label.ol-header.value'),
            strValueLabel: node._('disXmlState.label.ol-header.strvalue'),
            selectorLabel: node._('disXmlState.label.initState')
          });

        node._stateList.load({ list: node.states, value: node.initState } );
      },
      oneditsave: function() {
        const node = this;

        const ret = node._stateList.save()
        node.initState = ret.value;
        node.states = ret.list;
      },
      oneditresize: dimXml.utils.resizeDialog
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-state-server"></script>
